#include <string.h> 
#include <iostream>
#include <time.h>
#include "service.h"
#include "Schnittstelle.h"
#include "VokabelTrainer.h"

//Konsturktor
Schnittstelle::Schnittstelle()
{
	//Variablen init.
	_fehler = 0;
}

//Funktion zum schreiben der Vokabeln in die Datei
void Schnittstelle::in_Datei(char* deutsch, char* englisch)
{
	//Eingabe prfen, ob die Vokabeln nur Strings sind
	if (!check_isstring(deutsch))
	{
		_fehler = 1;
	}
	if (!check_isstring(englisch))
	{
		_fehler = 1;
	}

	//wenn alles Inordnung ist werden die Vokabeln getauscht
	if (_fehler == 0)
	{
		//Zwischenspiecher deklarieren
		Vokabeln temp;


		//Datei zum schreiben ffnen
		vokabeltrainer.open_my_datei(DATNAME, MODUS_SCHREIBEN);

		//falls es einen Fehler gibt eine Fehlermeldung ausgeben
		if (!vokabeltrainer.erfolgskontrolle())
		{
			_fehler = 1;
		}
		else
		{
			//Vokabeln in den Zwischenspeicher schreiben
			strcpy_s(temp.vokabel_deutsch, deutsch);
			strcpy_s(temp.vokabel_englisch, englisch);
			temp.richtige = 0;

			//Vokabeln in der Klasse speichern
			vokabeltrainer.set_my_vokabeln(temp);

			//Vokabeln in die Datei schreiben
			vokabeltrainer.Vok_in_Datei();

			//berprfen, ob alles erfolgreich war
			if (!vokabeltrainer.erfolgskontrolle())
			{
				_fehler = 1;
			}

			//Datei wieder schlieen
			vokabeltrainer.close_my_datei();

			//falls es einen Fehler gibt eine Fehlermeldung ausgeben
			if (!vokabeltrainer.erfolgskontrolle())
			{
				_fehler = 1;
			}
		}
	}
}

//Funktion zum ndern der Vokabel
void Schnittstelle::Vokabeln_aendern(int nummer, char* deutsch, char* englisch, int richtige)
{
	//Eingabe prfen, ob die Vokabeln nur Strings sind
	if (!check_isstring(deutsch))
	{
		_fehler = 1;
	}
	if (!check_isstring(englisch))
	{
		_fehler = 1;
	}

	//wenn alles Inordnung ist werden die Vokabeln getauscht
	if (_fehler == 0)
	{
		//Zwischenspeicher init.
		Vokabeln temp;

		//Vokabeln in den Zwischenspeicher schreiben
		strcpy_s(temp.vokabel_deutsch, deutsch);
		strcpy_s(temp.vokabel_englisch, englisch);
		temp.richtige = richtige;

		//neue Vokabel in der Klasse speichern
		vokabeltrainer.set_my_vokabeln(temp);

		//Datei zum ndern ffnen
		vokabeltrainer.open_my_datei(DATNAME, MODUS_AENDERN);

		//Fehler abfragen
		if (!vokabeltrainer.erfolgskontrolle())
		{
			_fehler = 1;
		}
		else
		{
			//Vokabel in der Datei ndern
			vokabeltrainer.Vok_in_Datei_aendern(nummer);

			//prfen, ob alles Inordnung ist
			if (!vokabeltrainer.erfolgskontrolle())
			{
				_fehler = 1;
			}

			//Datei schlieen
			vokabeltrainer.close_my_datei();

			//Fehler abfragen
			if (!vokabeltrainer.erfolgskontrolle())
			{
				_fehler = 1;
			}
		}
	}
}

//Funktion um alle Vokablen aus der Datei zu holen
void Schnittstelle::aus_Datei_alle(struct Vokabeln* temp)
{
	//Struktur fr die Aanzhal
	struct Anzahl anzahl;
	int i = 0;

	//Datei zum lesen ffnen
	vokabeltrainer.open_my_datei(DATNAME, MODUS_LESEN);

	//Fehler abfragen
	if (!vokabeltrainer.erfolgskontrolle())
	{
		_fehler = 1;
	}
	else
	{
		//Anzahl der Vokabeln holen
		anzahl = vokabeltrainer.get_anzahl();

		//for-Schleife um jeden Datensatz zu lesen
		for (i = 0; i < anzahl._anzahl_gesamt; i++)
		{
			//Vokabel aus der Datei lesen
			vokabeltrainer.Vok_aus_Datei(i);

			//Vokabel aus der Klasse holen und abspeichern
			temp[i] = *vokabeltrainer.get_my_vokabeln();
		}

		//Datei wieder schlieen
		vokabeltrainer.close_my_datei();

		//Fehler abfragen
		if (!vokabeltrainer.erfolgskontrolle())
		{
			_fehler = 1;
		}
	}
}

//Funktion zum erfassen und holen der Anzahl
struct Anzahl Schnittstelle::get_anzahl(void)
{
	//Zwischenspeicher deklarieren
	Anzahl anzahl_dummy;

	//Struktur init
	anzahl_dummy._anzahl_gesamt = 0;
	anzahl_dummy._anzahl_noch_zu_lernen = 0;

	//Datei zum lesen ffnen
	vokabeltrainer.open_my_datei(DATNAME, MODUS_LESEN);

	//Wenn es einen Fehler gab diesen abfragen
	if (!vokabeltrainer.erfolgskontrolle())
	{
		_fehler = 1;
	}
	else
	{
		//Dateigre erfassen
		vokabeltrainer.get_dateigroesse();

		//Datei wieder schlieen
		vokabeltrainer.close_my_datei();

		//Fehler abfragen
		if (!vokabeltrainer.erfolgskontrolle())
		{
			_fehler = 1;
		}

		//die Anzahl der Vokablen holen
		anzahl_dummy = vokabeltrainer.get_anzahl();
	}

	//Anzahl wird zurckgegeben
	return anzahl_dummy;
}

//Funktion, falls es einen Fehler gab, diesen dann zurckzugeben
int Schnittstelle::get_fehler(void)
{
	//Rckgabe des Fehlers
	return _fehler;
}

//Funktion zum reseten der Fehlervaraiblen
void Schnittstelle::reset_fehler()
{
	_fehler = 0;
}

//Funktion um eine zufllige Vokabel zu bekommen
struct Vokabeln* Schnittstelle::zufalls_Vokabel(int* nummer)
{
	int nummer_vokabel;
	time_t zeit;
	struct Anzahl anzahl;
	struct Vokabeln* vokabel;

	//Zeit nehmen um spter eine Zufallszahl zu generieren
	srand(time(&zeit));

	//Datei zum lesen ffnen
	vokabeltrainer.open_my_datei(DATNAME, MODUS_LESEN);

	//Fehler abfragen
	if (!vokabeltrainer.erfolgskontrolle())
	{
		_fehler = 1;
	}
	else
	{
		//Anzahl der Vokabel holen
		vokabeltrainer.get_dateigroesse();

		anzahl = vokabeltrainer.get_anzahl();

		//gibt es noch Vokabeln, die gelernt werden knnen
		if (anzahl._anzahl_noch_zu_lernen >= 1)
		{
			//Zufallszahl generieren
			nummer_vokabel = rand() % anzahl._anzahl_gesamt;

			//Stelle abspeichern
			*nummer = nummer_vokabel;

			do
			{
				//Vokabel aus der Datei lesen
				vokabeltrainer.Vok_aus_Datei(nummer_vokabel);

				//Vokabel auslesen aus der Klasse
				vokabel = vokabeltrainer.get_my_vokabeln();

			} while (vokabel->richtige >= 3);

			//Datei nach dem lesen wieder schlieen
			vokabeltrainer.close_my_datei();

			//Fehler abfragen
			if (!vokabeltrainer.erfolgskontrolle())
			{
				_fehler = 1;
			}

			return vokabel;
		}

		//Datei nach dem lesen wieder schlieen
		vokabeltrainer.close_my_datei();

		//Fehler abfragen
		if (!vokabeltrainer.erfolgskontrolle())
		{
			_fehler = 1;
		}
	}
}