#include <string.h> 
#include <iostream>
#include <fstream>
#include "service.h"
#include "Schnittstelle.h"
#include "VokabelTrainer.h"

using namespace std;

//berladener Konstruktor
VokabelTrainer::VokabelTrainer()
{
	//alle Variablen in der Klasse init.
	_my_vokabeln = new Vokabeln;
	_my_vokabeln->richtige = 0;
	_my_anzahl._anzahl_gesamt = 0;
	_my_anzahl._anzahl_noch_zu_lernen = 0;
	_erfolg = 1;
}

//Destruktor
VokabelTrainer::~VokabelTrainer()
{
	//beim beenden des Programms die Datei schlieen
	_my_datei.close();

	//dynamischen Speicher freigeben
	//delete _my_vokabeln;
}

//Funktion zum ffnen der Datei mit verschiedenen Varianten
void VokabelTrainer::open_my_datei(char* name, int modus)
{
	//Datei ffnen zum lesen
	if (modus == MODUS_LESEN)
	{
		_my_datei.open(name, ios::in | ios::binary);

		_erfolg = _my_datei.good();
	}
	//Datei ffnen zum schreiben
	else if (modus == MODUS_SCHREIBEN)
	{
		_my_datei.open(name, ios::app | ios::binary);

		_erfolg = _my_datei.good();
	}
	//Datei ffnen zum ndern der Vokabeln
	else if (modus == MODUS_AENDERN)
	{
		_my_datei.open(name, ios::out | ios::binary | ios::in);

		_erfolg = _my_datei.good();
	}
}

//Funktion zum schlieen der Datei
void VokabelTrainer::close_my_datei(void)
{
	_my_datei.clear();

	//Datei wird geschlossen
	_my_datei.close();

	_erfolg = _my_datei.good();
}

//Funktion zum speichern der Vokabeln in der Klasse
void VokabelTrainer::set_my_vokabeln(struct Vokabeln &temp)
{
	_my_vokabeln = &temp;
}

//Funktion um die Vokabel zurckzugeben
struct Vokabeln* VokabelTrainer::get_my_vokabeln(void)
{
	//Rckgabe der Vokabel
	return _my_vokabeln;
}

//Funktion zum schreiben der Vokabel in die Datei
void VokabelTrainer::Vok_in_Datei(void)
{
	//Vokabel in die Datei schreiben
	_my_datei.write((const char*)_my_vokabeln, sizeof(struct Vokabeln));

	//abfragen, ob es erfolgreich war
	_erfolg = _my_datei.good();
}

//Funktion zum ndern der Vokabeln
void VokabelTrainer::Vok_in_Datei_aendern(int nummer)
{
	//das eofbit und failbit zurcksetzen
	_my_datei.clear();

	//den Dateizeiger an die Stelle schieben, wo die Vokabel gendert werden soll
	_my_datei.seekg(nummer*(sizeof(struct Vokabeln)), ios::beg);

	//neue Vokabel in die Datei schreiben
	_my_datei.write((const char*)_my_vokabeln, sizeof(struct Vokabeln));

	//abfragen, ob es erfolgreich war
	_erfolg = _my_datei.good();
}

//Funktion zum lesen der Vokabel
void VokabelTrainer::Vok_aus_Datei(int nummer)
{
	_my_datei.clear();

	//an die entsprechende Stelle springen
	_my_datei.seekg(nummer*(sizeof(struct Vokabeln)), ios::beg);

	//Vokabel aus der Dtei lesen
	_my_datei.read((char*)(_my_vokabeln), sizeof(struct Vokabeln));

	//abfragen, ob es erfolgreich war
	_erfolg = _my_datei.good();
}

//Funktion zum erfassen der Dateigre
void VokabelTrainer::get_dateigroesse(void)
{
	// Zwischenspeicher deklarieren
	struct Anzahl dummy_anzahl;

	//Zhl Variable deklarieren
	int i = 0;

	//Zwischenspeicher initailisieren
	dummy_anzahl._anzahl_gesamt = 0;
	dummy_anzahl._anzahl_noch_zu_lernen = 0;

	//eofbit und failbit zurcksetzen damit der Zeiger zum Anfang der Datei gesetzt wird
	_my_datei.clear();

	//Dateizeiger auf den Anfnag setzten 
	_my_datei.seekg(0, ios::beg);

	//Schleife wird solange durchlaufen bis der Zeiger am Ende der Datei ist
	//whrenddessen wird die Anzahl der Datenstze gezhlt
	while (!_my_datei.eof())
	{
		//Daten aus der Datei lesen
		Vok_aus_Datei(i);

		//Variable hochzhlen
		i++;

		//Gseamtanzahl hochzhlen
		dummy_anzahl._anzahl_gesamt++;

		//Anzhal der noch lernenden Vokablen nur hochzhlen wenn die bisher < 3mal richtig war
		if (_my_vokabeln->richtige < 3)
		{
			//noch zu lernende Vokabeln hochzhlen
			dummy_anzahl._anzahl_noch_zu_lernen++;
		}
	}

	//Anzahl der Vokabeln in der Klasse speichern und um 1 verringern
	_my_anzahl._anzahl_gesamt = dummy_anzahl._anzahl_gesamt - 1;
	_my_anzahl._anzahl_noch_zu_lernen = dummy_anzahl._anzahl_noch_zu_lernen - 1;

	//eofbit und failbit zurcksetzen damit der Zeiger zum Anfang der Datei gesetzt wird
	_my_datei.clear();

	//Dateizeiger auf den Anfnag setzten 
	_my_datei.seekg(0, ios::beg);
}

//Funktion um die Anzahl der Vokabeln zurckzugeben
struct Anzahl VokabelTrainer::get_anzahl()
{
	//Rckgabe der Anzahl
	return _my_anzahl;
}

//Funktion um den Erfolg zurckzugeben
int VokabelTrainer::erfolgskontrolle(void)
{
	//Rckgabe, ob alles erfolgreich war
	return _erfolg;
}
