﻿#ifndef VOKABELTRAINER
#define VOKABELTRAINER

#include <fstream>

//Defines
#define DATNAME	"Vokablen.bin"
#define MODUS_LESEN 2
#define MODUS_SCHREIBEN 3
#define MODUS_AENDERN 4
#define KEIN_FEHLER 1
#define FEHLER -1

using namespace std;

//Struktur Vokabeln
struct Vokabeln
{
	char vokabel_deutsch[20], vokabel_englisch[20];
	int richtige;
};

//Struktur Anzahl
struct Anzahl													//wird benötigt, da für die Dimension der Zufallszahl 
{																//die Gesamtanzahl bekannt sein muss, für die Beendigung 
	//des Lernprozesses die Anzahl der noch zu lernenden Vokabeln
	int _anzahl_gesamt, _anzahl_noch_zu_lernen;
};

//Definition Klasse VokabelTrainer
class VokabelTrainer
{
private:
	fstream _my_datei;
	struct Vokabeln* _my_vokabeln;
	struct Anzahl _my_anzahl;
	int _erfolg;

public:
	VokabelTrainer();
	~VokabelTrainer();

	void open_my_datei(char*, int);
	void close_my_datei(void);
	void set_my_vokabeln(struct Vokabeln&);
	struct Vokabeln* get_my_vokabeln(void);
	void Vok_in_Datei(void);
	void Vok_in_Datei_aendern(int);
	void Vok_aus_Datei(int);
	void get_dateigroesse(void);
	struct Anzahl get_anzahl();
	int erfolgskontrolle(void);
};


#endif