/********************************************/
/*	Programm:	Programm zur Verwaltung 	*/
/*				eines Wartezimmers			*/
/*											*/
/*	Verfasser:	Kilian Kellermann			*/
/*											*/
/*	Version:	1.0							*/
/*											*/
/*	Datum:		21.05.15					*/
/********************************************/

#include <string.h> 
#include <iostream>
#include <time.h>
#include "service.h"
#include "VokabelTrainer.h"
#include "Schnittstelle.h"

#pragma comment(lib, "service.lib")
using namespace std;

/*Hautprogramm*/
int main(void)
{
	//Variablendeklaration
	char input[80], deutsch[20], englisch[20], neue_eingabe = 'j';
	int wiederholen = 0, modus, rc = 0;
	time_t zeit;
	int stelle_vokabel = 0;
	int* p_stelle_vokabel;
	int richtige = 0, anz_gepruefte_vok = 0;

	// Schnittstelle erstellen
	Schnittstelle schnittstelle;

	Anzahl anzahl;

	//Zeit nehmen um spter eine Zufallszahl zu generieren
	srand(time(&zeit));

	do
	{
		system("cls");
		wiederholen = 0;
		do
		{
			cout << "*****************************" << endl;
			cout << "*      Vokabel Trainer      *" << endl;
			cout << "*****************************" << endl;
			cout << "1: Vokabeln eingeben" << endl;
			cout << "2: Vokabeln aendern" << endl;
			cout << "3: Vokabeln lernen" << endl;
			cout << "0: Beenden" << endl << endl;
			cout << "> ";
			cin >> input;
			rc = check_input_int(input);
			fflush(stdin);

			if (rc == 1)
			{
				modus = atoi(input);

				//Modus checken
				rc = check_mode(modus, 3, 0);

				//Fehlermeldung
				if (rc != 1)
				{
					system("cls");
					cout << endl << endl << "Error! Bitte geben Sie den Modus erneut ein..." << endl << endl;
					cin.get();
				}
			}
			else
			{
				system("cls");
				cout << endl << endl << "Error! Bitte geben Sie den Modus erneut ein..." << endl << endl;
				cin.get();
			}


		} while (rc != 1);

		//Switch modus
		switch (modus)
		{
		case 1:
			//Modus Vokabeln eingeben
			system("cls");
			cout << ">*********** Modus: Vokabeln eingeben **********<" << endl << endl;

			//do-while Schleife damit man mehrere Vokabeln eingeben kann
			do
			{
				//Aufforderung zum eingeben der Vokabeln
				cout << endl << "Bitte geben Sie die Vokabeln ein!" << endl << endl;
				cout << "Vokabel deutsch: ";
				cin >> deutsch;
				cout << endl << "Vokabel englisch: ";
				cin >> englisch;

				//Vokabeln werden erst an die Klasse bergeben, dort dann abgespeichert
				//und dann in die Datei geschrieben
				schnittstelle.in_Datei(deutsch, englisch);

				//wenn es einen Fehler gibt dann eine Fehlermeldung ausgeben
				if (schnittstelle.get_fehler())
				{
					cout << endl << "Error! Eingabe konnte nicht durchgefuehrt werden..." << endl;

					//Fehler zurcksetzen
					schnittstelle.reset_fehler();
				}

				cout << endl << "Wollen Sie weitere Vokabeln eingeben? (j/n)" << endl;
				cout << ">";
				cin >> neue_eingabe;

			} while (neue_eingabe != 'n');

			break;

		case 2:
			//Modus Voabeln ndern
			system("cls");
			cout << ">*********** Modus: Vokabeln aendern **********<" << endl << endl;

			anzahl._anzahl_gesamt = 0;
			anzahl._anzahl_noch_zu_lernen = 0;

			//Anzahl der Datenstze in der Datei erfassen
			anzahl = schnittstelle.get_anzahl();

			if (schnittstelle.get_fehler())
			{
				cout << endl << "Error! Die Anzahl der Datensaetze konnte nicht gelesen werden..." << endl;
				cin.get();
				fflush(stdin);

				//Fehler zurcksetzen
				schnittstelle.reset_fehler();
			}
			else
			{
				//sind Datenstze vorhanden
				//ja -> alle Datenstze werden ausgegeben und die entsprechende Vokabel gendert
				//nein -> Fehler
				if (anzahl._anzahl_gesamt > 0)
				{
					//do-while Schleife falls mehrere Vokabeln gendert werden sollen
					do
					{
						//Struktur deklaraieren
						Vokabeln *alle_vokabeln;

						//Speicher fr alle Vokabeln dynamisch reservieren
						alle_vokabeln = new(Vokabeln[anzahl._anzahl_gesamt]);

						//alle Vokabeln auslesen
						schnittstelle.aus_Datei_alle(alle_vokabeln);

						//alle Vokabeln werden ausgegeben
						cout << "\tDeutsch" << "\t\t\tEnglisch" << "\t\tRichtig" << endl;
						for (int i = 0; i < anzahl._anzahl_gesamt; i++)
						{
							cout << i << ".	" << alle_vokabeln->vokabel_deutsch << "\t\t\t" << alle_vokabeln->vokabel_englisch << "\t\t\t" << alle_vokabeln->richtige << endl;
							alle_vokabeln++;
						}

						//einlesen der nummer die gendert werden soll
						cout << endl << endl << "Bitte geben Sie die Nummer ein, die Sie aendern moechten: ";
						cin >> input;

						rc = check_input_int(input);

						if (rc == 1)
						{
							//Nummer wird in ein integer umgewandelt
							stelle_vokabel = atoi(input);

							//Anzahl der Datenstze holen
							anzahl = schnittstelle.get_anzahl();

							//Modus checken
							rc = check_mode(stelle_vokabel, anzahl._anzahl_gesamt, 0);

							//Fehlermeldung
							if (rc != 1)
							{
								cout << endl << "Error! Stelle ist nicht korrekt..." << endl;
								cin.get();
								fflush(stdin);
							}
							else
							{
								//Eingabe der neuen Vokabel
								cout << endl << "Bitte geben Sie die Vokabeln ein!" << endl << endl;
								cout << "Vokabel deutsch: ";
								cin >> deutsch;
								cout << endl << "Vokabel englisch: ";
								cin >> englisch;
								fflush(stdin);

								//Vokabel ndern
								schnittstelle.Vokabeln_aendern(stelle_vokabel, deutsch, englisch, 0);

								//abfragen, ob ein Fehler aufgetreten ist
								if (schnittstelle.get_fehler())
								{
									cout << endl << "Error! Eingabe konnte nicht durchgefuehrt werden..." << endl;
									cin.get();

									//Fehler zurcksetzen
									schnittstelle.reset_fehler();
								}
							}
						}
						else
						{
							cout << endl << "Error! Stelle ist nicht korrekt..." << endl;
							cin.get();
							fflush(stdin);
						}

						//Soll eine weitere Vokabel gendert werden?
						cout << endl << "Wollen Sie weitere Vokabeln eingeben? (j/n)" << endl;
						cout << ">";
						cin >> neue_eingabe;

						//Speicher freigeben
						delete alle_vokabeln;

					} while (neue_eingabe != 'n');
				}
				else
				{
					//Fehlermeldung wird ausgegeben
					cout << endl << endl << "Error! Datei enthaelt keine Datensaetze..." << endl << endl;
					cin.get();
					fflush(stdin);

					//Fehler zurcksetzen
					schnittstelle.reset_fehler();
				}
			}




			//dynamischen Speicher freigeben
			//delete alle_vokabeln;

			break;

		case 3:
			//Modus Lernen
			system("cls");
			cout << ">*********** Modus: Vokabeln lernen **********<" << endl << endl;

			//Strukturen erstellen
			Vokabeln *vokabel;

			//Adresse abspeichern
			p_stelle_vokabel = &stelle_vokabel;

			//Anzhal der Vokabeln holen
			anzahl = schnittstelle.get_anzahl();

			if (schnittstelle.get_fehler())
			{
				cout << endl << "Error! Die Anzahl der Datensaetze konnte nicht gelesen werden..." << endl;
				cin.get();
				fflush(stdin);

				//Fehler zurcksetzen
				schnittstelle.reset_fehler();
			}
			else
			{
				//Trainer nur starten wenn es schon Datenstze gibt
				if (anzahl._anzahl_gesamt > 0)
				{
					cout << "Der Trainer wird gestartet..." << endl;
					cout << "Beendet wird mit einem Punkt!" << endl;

					if (anzahl._anzahl_noch_zu_lernen > 0)
					{
						do
						{
							//Zufallsvokabel holen
							vokabel = schnittstelle.zufalls_Vokabel(p_stelle_vokabel);

							//unterscheiden, ob die englische oder deutsche Vokabel ausgegeben werden soll
							if (rand() % 2)
							{
								cout << endl << "Deutsch: " << vokabel->vokabel_deutsch << endl;
								cout << "Englisch: ";
								cin >> input;
								fflush(stdin);

								if (strcmp(".", input))
								{
									if (!strcmp(input, vokabel->vokabel_englisch))
									{
										cout << endl << "Vokabel ist richtig!" << endl;
										cin.get();
										fflush(stdin);
										richtige++;
										vokabel->richtige++;

										//neuen "richtige"-Wert in die Datei schreiben
										schnittstelle.Vokabeln_aendern(stelle_vokabel, vokabel->vokabel_deutsch, vokabel->vokabel_englisch, vokabel->richtige);

										if (schnittstelle.get_fehler())
										{
											cout << endl << "Error! Lernfortschritt konnte nicht erneuert werden..." << endl;
											cin.get();
											fflush(stdin);

											//Fehler zurcksetzen
											schnittstelle.reset_fehler();

											break;
										}

										//Anzahl noch zu lernen runterzhlern
										if (vokabel->richtige >= 3)
										{
											anzahl._anzahl_noch_zu_lernen--;
										}
									}
									else
									{
										cout << endl << "Vokabel ist falsch!" << endl;
										cout << "Richtig ist -> " << vokabel->vokabel_englisch << endl;
										cin.get();
										fflush(stdin);

										if (vokabel->richtige > 1)
										{
											vokabel->richtige--;

											//neuen "richtige"-Wert in die Datei schreiben
											schnittstelle.Vokabeln_aendern(stelle_vokabel, vokabel->vokabel_deutsch, vokabel->vokabel_englisch, vokabel->richtige);

											if (schnittstelle.get_fehler())
											{
												cout << endl << "Error! Lernfortschritt konnte nicht erneuert werden..." << endl;
												cin.get();
												fflush(stdin);

												//Fehler zurcksetzen
												schnittstelle.reset_fehler();

												break;
											}
										}
									}
								}
								else
								{
									cout << endl << "Trainer wird beendet!" << endl;
									cin.get();
									fflush(stdin);
									break;
								}
							}
							else
							{
								cout << endl << "Englisch: " << vokabel->vokabel_englisch << endl;
								cout << "Deutsch: ";
								cin >> input;
								fflush(stdin);

								if (strcmp(".", input))
								{
									if (!strcmp(input, vokabel->vokabel_deutsch))
									{
										cout << endl << "Vokabel ist richtig!" << endl;
										cin.get();
										fflush(stdin);
										richtige++;
										vokabel->richtige++;

										//neuen "richtige"-Wert in die Datei schreiben
										schnittstelle.Vokabeln_aendern(stelle_vokabel, vokabel->vokabel_deutsch, vokabel->vokabel_englisch, vokabel->richtige);

										if (schnittstelle.get_fehler())
										{
											cout << endl << "Error! Lernfortschritt konnte nicht erneuert werden..." << endl;
											cin.get();
											fflush(stdin);

											//Fehler zurcksetzen
											schnittstelle.reset_fehler();

											break;
										}

										//Anzahl noch zu lernen runterzhlern
										if (vokabel->richtige >= 3)
										{
											anzahl._anzahl_noch_zu_lernen--;
										}
									}
									else
									{
										cout << endl << "Vokabel ist falsch!" << endl;
										cout << "Richtig ist -> " << vokabel->vokabel_deutsch << endl;
										cin.get();
										fflush(stdin);

										if (vokabel->richtige > 1)
										{
											vokabel->richtige--;

											//neuen "richtige"-Wert in die Datei schreiben
											schnittstelle.Vokabeln_aendern(stelle_vokabel, vokabel->vokabel_deutsch, vokabel->vokabel_englisch, vokabel->richtige);

											if (schnittstelle.get_fehler())
											{
												cout << endl << "Error! Lernfortschritt konnte nicht erneuert werden..." << endl;
												cin.get();
												fflush(stdin);

												//Fehler zurcksetzen
												schnittstelle.reset_fehler();

												break;
											}
										}
									}
								}
								else
								{
									cout << endl << "Trainer wird beendet!" << endl;
									break;
								}
							}

							anz_gepruefte_vok++;
							system("cls");

						} while (anzahl._anzahl_noch_zu_lernen != 0);

						if (anzahl._anzahl_noch_zu_lernen == 0)
						{
							cout << endl << "Es wurden alle verfuegbaren Vokabeln gelernt!" << endl;
						}

						//Ergebnis ausgeben
						cout << endl << "Sie haben " << richtige << " von " << anz_gepruefte_vok << " richtig beantwortet!" << endl;
						cin.get();
					}
				}
			}

			break;

		case 0:
			wiederholen = 1;		//Programm beenden
			break;

		default:
			cout << endl << endl << "Error! Fehlerhafte Eingabe..." << endl << endl;
			break;
		}

	} while (wiederholen != 1);

	return(1);
}
/*Ende Hauptprogramm*/
